org.apache.xml.utils

## Class UnImplNode

- java.lang.Object
- - org.apache.xml.utils.UnImplNode

All Implemented Interfaces:
  Document, Element, Node, NodeList

Direct Known Subclasses:
  ElemTemplateElement

    public class UnImplNode
    extends java.lang.Object
    implements Node, Element, NodeList, Document

To be subclassed by classes that wish to fake being nodes.

Usage:
  **For internal use only**

### Field Summary

### Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

### Constructor Summary

Constructors
Constructor and Description
`UnImplNode()` Constructor UnImplNode

### Method Summary

Methods
`Node` `adoptNode(Node source)` NEEDSDOC Method adoptNode NEEDSDOC @param source NEEDSDOC (adoptNode) @return
`Node` `appendChild(Node newChild)` Unimplemented.
`void` `appendData(java.lang.String arg)` Unimplemented.
`Node` `cloneNode(boolean deep)` Unimplemented.
`short` `compareDocumentPosition(Node other)` Compares a node with this node with regard to their position in the document.
`Attr` `createAttribute(java.lang.String name)` Unimplemented.
`Attr` `createAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName)` Unimplemented.
`CDATASection` `createCDATASection(java.lang.String data)` Unimplemented.
`Comment` `createComment(java.lang.String data)` Unimplemented.
`DocumentFragment` `createDocumentFragment()` Unimplemented.
`Element` `createElement(java.lang.String tagName)` Unimplemented.
`Element` `createElementNS(java.lang.String namespaceURI, java.lang.String qualifiedName)` Unimplemented.
`EntityReference` `createEntityReference(java.lang.String name)` Unimplemented.
`ProcessingInstruction` `createProcessingInstruction(java.lang.String target, java.lang.String data)` Unimplemented.
`Text` `createTextNode(java.lang.String data)` Unimplemented.
`void` `deleteData(int offset, int count)` Unimplemented.
`void` `error(java.lang.String msg)` Throw an error.
`void` `error(java.lang.String msg, java.lang.Object[] args)` Throw an error.
`java.lang.String` `getActualEncoding()` DOM Level 3 An attribute specifying the actual encoding of this document.
`java.lang.String` `getAttribute(java.lang.String name)` Unimplemented.
`Attr` `getAttributeNode(java.lang.String name)` Unimplemented.
`Attr` `getAttributeNodeNS(java.lang.String namespaceURI, java.lang.String localName)` Unimplemented.
`java.lang.String` `getAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Unimplemented.
`NamedNodeMap` `getAttributes()` Unimplemented.
`java.lang.String` `getBaseURI()` The absolute base URI of this node or `null` if undefined.
`NodeList` `getChildNodes()` Unimplemented.
`DocumentType` `getDoctype()` Unimplemented.
`Element` `getDocumentElement()` Unimplemented.
`java.lang.String` `getDocumentURI()` DOM Level 3 The location of the document or `null` if undefined.
`DOMConfiguration` `getDomConfig()` The configuration used when `Document.normalizeDocument` is invoked.
`Element` `getElementById(java.lang.String elementId)` Unimplemented.
`NodeList` `getElementsByTagName(java.lang.String name)` Unimplemented.
`NodeList` `getElementsByTagNameNS(java.lang.String namespaceURI, java.lang.String localName)` Unimplemented.
`java.lang.Object` `getFeature(java.lang.String feature, java.lang.String version)` This method returns a specialized object which implements the specialized APIs of the specified feature and version.
`Node` `getFirstChild()` Unimplemented.
`DOMImplementation` `getImplementation()` Unimplemented.
`java.lang.String` `getInputEncoding()` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
`Node` `getLastChild()` Unimplemented.
`int` `getLength()` Unimplemented.
`java.lang.String` `getLocalName()` Unimplemented.
`java.lang.String` `getNamespaceURI()` Unimplemented.
`Node` `getNextSibling()` Unimplemented.
`java.lang.String` `getNodeName()` Unimplemented.
`short` `getNodeType()` Unimplemented.
`java.lang.String` `getNodeValue()` Unimplemented.
`Document` `getOwnerDocument()` Unimplemented.
`Element` `getOwnerElement()` Unimplemented.
`Node` `getParentNode()` Unimplemented.
`java.lang.String` `getPrefix()` Unimplemented.
`Node` `getPreviousSibling()` Unimplemented.
`TypeInfo` `getSchemaTypeInfo()` Method getSchemaTypeInfo.
`boolean` `getSpecified()` Unimplemented.
`boolean` `getStrictErrorChecking()` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
`java.lang.String` `getTagName()` Unimplemented.
`java.lang.String` `getTextContent()` This attribute returns the text content of this node and its descendants.
`java.lang.Object` `getUserData(java.lang.String key)` Retrieves the object associated to a key on a this node.
`java.lang.String` `getWholeText()` DOM Level 3 Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
`java.lang.String` `getXmlEncoding()` An attribute specifying, as part of the XML declaration, the encoding of this document.
`boolean` `getXmlStandalone()` An attribute specifying, as part of the XML declaration, whether this document is standalone.
`java.lang.String` `getXmlVersion()` An attribute specifying, as part of the XML declaration, the version number of this document.
`boolean` `hasAttribute(java.lang.String name)` Unimplemented.
`boolean` `hasAttributeNS(java.lang.String name, java.lang.String x)` Unimplemented.
`boolean` `hasAttributes()` Unimplemented.
`boolean` `hasChildNodes()` Unimplemented.
`Node` `importNode(Node importedNode, boolean deep)` Unimplemented.
`Node` `insertBefore(Node newChild, Node refChild)` Unimplemented.
`void` `insertData(int offset, java.lang.String arg)` Unimplemented.
`boolean` `isDefaultNamespace(java.lang.String namespaceURI)` DOM Level 3: This method checks if the specified `namespaceURI` is the default namespace or not.
`boolean` `isEqualNode(Node arg)` Tests whether two nodes are equal.
`boolean` `isId()`
`boolean` `isSameNode(Node other)` Returns whether this node is the same node as the given one.
`boolean` `isSupported(java.lang.String feature, java.lang.String version)` Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.
`boolean` `isWhitespaceInElementContent()` DOM Level 3 Returns whether this text node contains whitespace in element content, often abusively called "ignorable whitespace".
`Node` `item(int index)` Unimplemented.
`java.lang.String` `lookupNamespaceURI(java.lang.String specifiedPrefix)` DOM Level 3: Look up the namespace URI associated to the given prefix, starting from this node.
`java.lang.String` `lookupPrefix(java.lang.String namespaceURI)` DOM Level 3: Look up the prefix associated to the given namespace URI, starting from this node.
`void` `normalize()` Unimplemented.
`void` `normalizeDocument()` DOM Level 3 Normalize document.
`void` `removeAttribute(java.lang.String name)` Unimplemented.
`Attr` `removeAttributeNode(Attr oldAttr)` Unimplemented.
`void` `removeAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Unimplemented.
`Node` `removeChild(Node oldChild)` Unimplemented.
`Node` `renameNode(Node n, java.lang.String namespaceURI, java.lang.String name)` DOM Level 3 Renaming node
`Node` `replaceChild(Node newChild, Node oldChild)` Unimplemented.
`void` `replaceData(int offset, int count, java.lang.String arg)` Unimplemented.
`Text` `replaceWholeText(java.lang.String content)` DOM Level 3
`void` `setActualEncoding(java.lang.String value)` DOM Level 3 An attribute specifying the actual encoding of this document.
`void` `setAttribute(java.lang.String name, java.lang.String value)` Unimplemented.
`Attr` `setAttributeNode(Attr newAttr)` Unimplemented.
`Attr` `setAttributeNodeNS(Attr newAttr)` Unimplemented.
`void` `setAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName, java.lang.String value)` Unimplemented.
`void` `setData(java.lang.String data)` Set Node data
`void` `setDocumentURI(java.lang.String documentURI)` DOM Level 3
`void` `setIdAttribute(boolean id)` NON-DOM: set the type of this attribute to be ID type.
`void` `setIdAttribute(java.lang.String name, boolean makeId)` DOM Level 3: register the given attribute node as an ID attribute
`void` `setIdAttributeNode(Attr at, boolean makeId)` DOM Level 3: register the given attribute node as an ID attribute
`void` `setIdAttributeNS(java.lang.String namespaceURI, java.lang.String localName, boolean makeId)` DOM Level 3: register the given attribute node as an ID attribute
`void` `setInputEncoding(java.lang.String encoding)` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
`void` `setNodeValue(java.lang.String nodeValue)` Unimplemented.
`void` `setPrefix(java.lang.String prefix)` Unimplemented.
`void` `setStrictErrorChecking(boolean strictErrorChecking)` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
`void` `setTextContent(java.lang.String textContent)` This attribute returns the text content of this node and its descendants.
`java.lang.Object` `setUserData(java.lang.String key, java.lang.Object data, UserDataHandler handler)` Associate an object to a key on this node.
`void` `setValue(java.lang.String value)` Unimplemented.
`void` `setXmlEncoding(java.lang.String xmlEncoding)`
`void` `setXmlStandalone(boolean xmlStandalone)` An attribute specifying, as part of the XML declaration, whether this document is standalone.
`void` `setXmlVersion(java.lang.String xmlVersion)` An attribute specifying, as part of the XML declaration, the version number of this document.
`Text` `splitText(int offset)` Unimplemented.
`java.lang.String` `substringData(int offset, int count)` Unimplemented.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### UnImplNode

    public UnImplNode()

Constructor UnImplNode

### Method Detail

#### error

    public void error(java.lang.String msg)

Throw an error.

Parameters:
  `msg` - Message Key for the error

#### error

    public void error(java.lang.String msg,
             java.lang.Object[] args)

Throw an error.

Parameters:
  `msg` - Message Key for the error
  `args` - Array of arguments to be used in the error message

#### appendChild

    public Node appendChild(Node newChild)
                     throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `appendChild` in interface `Node`
Parameters:
  `newChild` - New node to append to the list of this node's children
Returns:
  null
Throws:
  `DOMException`

#### hasChildNodes

    public boolean hasChildNodes()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `hasChildNodes` in interface `Node`
Returns:
  false

#### getNodeType

    public short getNodeType()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getNodeType` in interface `Node`
Returns:
  0

#### getParentNode

    public Node getParentNode()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getParentNode` in interface `Node`
Returns:
  null

#### getChildNodes

    public NodeList getChildNodes()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getChildNodes` in interface `Node`
Returns:
  null

#### getFirstChild

    public Node getFirstChild()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getFirstChild` in interface `Node`
Returns:
  null

#### getLastChild

    public Node getLastChild()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getLastChild` in interface `Node`
Returns:
  null

#### getNextSibling

    public Node getNextSibling()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getNextSibling` in interface `Node`
Returns:
  null

#### getLength

    public int getLength()

Unimplemented. See org.w3c.dom.NodeList

Specified by:
  `getLength` in interface `NodeList`
Returns:
  0

#### item

    public Node item(int index)

Unimplemented. See org.w3c.dom.NodeList

Specified by:
  `item` in interface `NodeList`
Parameters:
  `index` - index of a child of this node in its list of children
Returns:
  null

#### getOwnerDocument

    public Document getOwnerDocument()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getOwnerDocument` in interface `Node`
Returns:
  null

#### getTagName

    public java.lang.String getTagName()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getTagName` in interface `Element`
Returns:
  null

#### getNodeName

    public java.lang.String getNodeName()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getNodeName` in interface `Node`
Returns:
  null

#### normalize

    public void normalize()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `normalize` in interface `Node`

#### getElementsByTagName

    public NodeList getElementsByTagName(java.lang.String name)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `getElementsByTagName` in interface `Document`
Specified by:
  `getElementsByTagName` in interface `Element`
Parameters:
  `name` - Name of the element
Returns:
  null

#### removeAttributeNode

    public Attr removeAttributeNode(Attr oldAttr)
                             throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `removeAttributeNode` in interface `Element`
Parameters:
  `oldAttr` - Attribute to be removed from this node's list of attributes
Returns:
  null
Throws:
  `DOMException`

#### setAttributeNode

    public Attr setAttributeNode(Attr newAttr)
                          throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `setAttributeNode` in interface `Element`
Parameters:
  `newAttr` - Attribute node to be added to this node's list of attributes
Returns:
  null
Throws:
  `DOMException`

#### hasAttribute

    public boolean hasAttribute(java.lang.String name)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `hasAttribute` in interface `Element`
Parameters:
  `name` - Name of an attribute
Returns:
  false

#### hasAttributeNS

    public boolean hasAttributeNS(java.lang.String name,
                         java.lang.String x)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `hasAttributeNS` in interface `Element`
Parameters:
  `name` -
  `x` -
Returns:
  false

#### getAttributeNode

    public Attr getAttributeNode(java.lang.String name)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `getAttributeNode` in interface `Element`
Parameters:
  `name` - Attribute node name
Returns:
  null

#### removeAttribute

    public void removeAttribute(java.lang.String name)
                         throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `removeAttribute` in interface `Element`
Parameters:
  `name` - Attribute node name to remove from list of attributes
Throws:
  `DOMException`

#### setAttribute

    public void setAttribute(java.lang.String name,
                    java.lang.String value)
                      throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `setAttribute` in interface `Element`
Parameters:
  `name` - Name of attribute to set
  `value` - Value of attribute
Throws:
  `DOMException`

#### getAttribute

    public java.lang.String getAttribute(java.lang.String name)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `getAttribute` in interface `Element`
Parameters:
  `name` - Name of attribute to get
Returns:
  null

#### hasAttributes

    public boolean hasAttributes()

Unimplemented. Introduced in DOM Level 2.

Specified by:
  `hasAttributes` in interface `Node`
Returns:
  false

#### getElementsByTagNameNS

    public NodeList getElementsByTagNameNS(java.lang.String namespaceURI,
                                  java.lang.String localName)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `getElementsByTagNameNS` in interface `Document`
Specified by:
  `getElementsByTagNameNS` in interface `Element`
Parameters:
  `namespaceURI` - Namespace URI of the element
  `localName` - Local part of qualified name of the element
Returns:
  null

#### setAttributeNodeNS

    public Attr setAttributeNodeNS(Attr newAttr)
                            throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `setAttributeNodeNS` in interface `Element`
Parameters:
  `newAttr` - Attribute to set
Returns:
  null
Throws:
  `DOMException`

#### getAttributeNodeNS

    public Attr getAttributeNodeNS(java.lang.String namespaceURI,
                          java.lang.String localName)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `getAttributeNodeNS` in interface `Element`
Parameters:
  `namespaceURI` - Namespace URI of attribute node to get
  `localName` - Local part of qualified name of attribute node to get
Returns:
  null

#### removeAttributeNS

    public void removeAttributeNS(java.lang.String namespaceURI,
                         java.lang.String localName)
                           throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `removeAttributeNS` in interface `Element`
Parameters:
  `namespaceURI` - Namespace URI of attribute node to remove
  `localName` - Local part of qualified name of attribute node to remove
Throws:
  `DOMException`

#### setAttributeNS

    public void setAttributeNS(java.lang.String namespaceURI,
                      java.lang.String qualifiedName,
                      java.lang.String value)
                        throws DOMException

Unimplemented. See org.w3c.dom.Element

Specified by:
  `setAttributeNS` in interface `Element`
Parameters:
  `namespaceURI` - Namespace URI of attribute node to set NEEDSDOC @param qualifiedName
  `value` - value of attribute
  `qualifiedName` - The qualified name of the attribute to create or alter.
Throws:
  `DOMException`

#### getAttributeNS

    public java.lang.String getAttributeNS(java.lang.String namespaceURI,
                                  java.lang.String localName)

Unimplemented. See org.w3c.dom.Element

Specified by:
  `getAttributeNS` in interface `Element`
Parameters:
  `namespaceURI` - Namespace URI of attribute node to get
  `localName` - Local part of qualified name of attribute node to get
Returns:
  null

#### getPreviousSibling

    public Node getPreviousSibling()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getPreviousSibling` in interface `Node`
Returns:
  null

#### cloneNode

    public Node cloneNode(boolean deep)

Unimplemented. See org.w3c.dom.Node

Specified by:
  `cloneNode` in interface `Node`
Parameters:
  `deep` - Flag indicating whether to clone deep (clone member variables)
Returns:
  null

#### getNodeValue

    public java.lang.String getNodeValue()
                                  throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getNodeValue` in interface `Node`
Returns:
  null
Throws:
  `DOMException`

#### setNodeValue

    public void setNodeValue(java.lang.String nodeValue)
                      throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `setNodeValue` in interface `Node`
Parameters:
  `nodeValue` - Value to set this node to
Throws:
  `DOMException`

#### setValue

    public void setValue(java.lang.String value)
                  throws DOMException

Unimplemented. See org.w3c.dom.Node

Parameters:
  `value` - Value to set this node to
Throws:
  `DOMException`

#### getOwnerElement

    public Element getOwnerElement()

Unimplemented. See org.w3c.dom.Node

Returns:
  null

#### getSpecified

    public boolean getSpecified()

Unimplemented. See org.w3c.dom.Node

Returns:
  False

#### getAttributes

    public NamedNodeMap getAttributes()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getAttributes` in interface `Node`
Returns:
  null

#### insertBefore

    public Node insertBefore(Node newChild,
                    Node refChild)
                      throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `insertBefore` in interface `Node`
Parameters:
  `newChild` - New child node to insert
  `refChild` - Insert in front of this child
Returns:
  null
Throws:
  `DOMException`

#### replaceChild

    public Node replaceChild(Node newChild,
                    Node oldChild)
                      throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `replaceChild` in interface `Node`
Parameters:
  `newChild` - Replace existing child with this one
  `oldChild` - Existing child to be replaced
Returns:
  null
Throws:
  `DOMException`

#### removeChild

    public Node removeChild(Node oldChild)
                     throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `removeChild` in interface `Node`
Parameters:
  `oldChild` - Child to be removed
Returns:
  null
Throws:
  `DOMException`

#### isSupported

    public boolean isSupported(java.lang.String feature,
                      java.lang.String version)

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Specified by:
  `isSupported` in interface `Node`
Parameters:
  `feature` - The name of the feature to test. This is the same name which can be passed to the method `hasFeature` on `DOMImplementation`.
  `version` - This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.
Returns:
  Returns `false`
Since:
  DOM Level 2

#### getNamespaceURI

    public java.lang.String getNamespaceURI()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getNamespaceURI` in interface `Node`
Returns:
  null

#### getPrefix

    public java.lang.String getPrefix()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getPrefix` in interface `Node`
Returns:
  null

#### setPrefix

    public void setPrefix(java.lang.String prefix)
                   throws DOMException

Unimplemented. See org.w3c.dom.Node

Specified by:
  `setPrefix` in interface `Node`
Parameters:
  `prefix` - Prefix to set for this node
Throws:
  `DOMException`

#### getLocalName

    public java.lang.String getLocalName()

Unimplemented. See org.w3c.dom.Node

Specified by:
  `getLocalName` in interface `Node`
Returns:
  null

#### getDoctype

    public DocumentType getDoctype()

Unimplemented. See org.w3c.dom.Document

Specified by:
  `getDoctype` in interface `Document`
Returns:
  null

#### getImplementation

    public DOMImplementation getImplementation()

Unimplemented. See org.w3c.dom.Document

Specified by:
  `getImplementation` in interface `Document`
Returns:
  null

#### getDocumentElement

    public Element getDocumentElement()

Unimplemented. See org.w3c.dom.Document

Specified by:
  `getDocumentElement` in interface `Document`
Returns:
  null

#### createElement

    public Element createElement(java.lang.String tagName)
                          throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createElement` in interface `Document`
Parameters:
  `tagName` - Element tag name
Returns:
  null
Throws:
  `DOMException`

#### createDocumentFragment

    public DocumentFragment createDocumentFragment()

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createDocumentFragment` in interface `Document`
Returns:
  null

#### createTextNode

    public Text createTextNode(java.lang.String data)

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createTextNode` in interface `Document`
Parameters:
  `data` - Data for text node
Returns:
  null

#### createComment

    public Comment createComment(java.lang.String data)

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createComment` in interface `Document`
Parameters:
  `data` - Data for comment
Returns:
  null

#### createCDATASection

    public CDATASection createCDATASection(java.lang.String data)
                                    throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createCDATASection` in interface `Document`
Parameters:
  `data` - Data for CDATA section
Returns:
  null
Throws:
  `DOMException`

#### createProcessingInstruction

    public ProcessingInstruction createProcessingInstruction(java.lang.String target,
                                                    java.lang.String data)
                                                      throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createProcessingInstruction` in interface `Document`
Parameters:
  `target` - Target for Processing instruction
  `data` - Data for Processing instruction
Returns:
  null
Throws:
  `DOMException`

#### createAttribute

    public Attr createAttribute(java.lang.String name)
                         throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createAttribute` in interface `Document`
Parameters:
  `name` - Attribute name
Returns:
  null
Throws:
  `DOMException`

#### createEntityReference

    public EntityReference createEntityReference(java.lang.String name)
                                          throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createEntityReference` in interface `Document`
Parameters:
  `name` - Entity Reference name
Returns:
  null
Throws:
  `DOMException`

#### importNode

    public Node importNode(Node importedNode,
                  boolean deep)
                    throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `importNode` in interface `Document`
Parameters:
  `importedNode` - The node to import.
  `deep` - If `true`, recursively import the subtree under the specified node; if `false`, import only the node itself, as explained above. This has no effect on `Attr` , `EntityReference`, and `Notation` nodes.
Returns:
  null
Throws:
  `DOMException`

#### createElementNS

    public Element createElementNS(java.lang.String namespaceURI,
                          java.lang.String qualifiedName)
                            throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createElementNS` in interface `Document`
Parameters:
  `namespaceURI` - Namespace URI for the element
  `qualifiedName` - Qualified name of the element
Returns:
  null
Throws:
  `DOMException`

#### createAttributeNS

    public Attr createAttributeNS(java.lang.String namespaceURI,
                         java.lang.String qualifiedName)
                           throws DOMException

Unimplemented. See org.w3c.dom.Document

Specified by:
  `createAttributeNS` in interface `Document`
Parameters:
  `namespaceURI` - Namespace URI of the attribute
  `qualifiedName` - Qualified name of the attribute
Returns:
  null
Throws:
  `DOMException`

#### getElementById

    public Element getElementById(java.lang.String elementId)

Unimplemented. See org.w3c.dom.Document

Specified by:
  `getElementById` in interface `Document`
Parameters:
  `elementId` - ID of the element to get
Returns:
  null

#### setData

    public void setData(java.lang.String data)
                 throws DOMException

Set Node data

Parameters:
  `data` - data to set for this node
Throws:
  `DOMException`

#### substringData

    public java.lang.String substringData(int offset,
                                 int count)
                                   throws DOMException

Unimplemented.

Parameters:
  `offset` - Start offset of substring to extract.
  `count` - The length of the substring to extract.
Returns:
  null
Throws:
  `DOMException`

#### appendData

    public void appendData(java.lang.String arg)
                    throws DOMException

Unimplemented.

Parameters:
  `arg` - String data to append
Throws:
  `DOMException`

#### insertData

    public void insertData(int offset,
                  java.lang.String arg)
                    throws DOMException

Unimplemented.

Parameters:
  `offset` - Start offset of substring to insert. NEEDSDOC @param arg
Throws:
  `DOMException`

#### deleteData

    public void deleteData(int offset,
                  int count)
                    throws DOMException

Unimplemented.

Parameters:
  `offset` - Start offset of substring to delete.
  `count` - The length of the substring to delete.
Throws:
  `DOMException`

#### replaceData

    public void replaceData(int offset,
                   int count,
                   java.lang.String arg)
                     throws DOMException

Unimplemented.

Parameters:
  `offset` - Start offset of substring to replace.
  `count` - The length of the substring to replace.
  `arg` - substring to replace with
Throws:
  `DOMException`

#### splitText

    public Text splitText(int offset)
                   throws DOMException

Unimplemented.

Parameters:
  `offset` - Offset into text to split
Returns:
  null, unimplemented
Throws:
  `DOMException`

#### adoptNode

    public Node adoptNode(Node source)
                   throws DOMException

NEEDSDOC Method adoptNode NEEDSDOC @param source NEEDSDOC (adoptNode) @return

Specified by:
  `adoptNode` in interface `Document`
Parameters:
  `source` - The node to move into this document.
Returns:
  The adopted node, or `null` if this operation fails, such as when the source node comes from a different implementation.
Throws:
  `DOMException`

#### getInputEncoding

    public java.lang.String getInputEncoding()

Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

An attribute specifying, as part of the XML declaration, the encoding of this document. This is `null` when unspecified.

Specified by:
  `getInputEncoding` in interface `Document`
Since:
  DOM Level 3 NEEDSDOC ($objectName$) @return

#### setInputEncoding

    public void setInputEncoding(java.lang.String encoding)

Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

An attribute specifying, as part of the XML declaration, the encoding of this document. This is `null` when unspecified.

Since:
  DOM Level 3 NEEDSDOC @param encoding

#### getStrictErrorChecking

    public boolean getStrictErrorChecking()

Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

Specified by:
  `getStrictErrorChecking` in interface `Document`
Since:
  DOM Level 3 NEEDSDOC ($objectName$) @return

#### setStrictErrorChecking

    public void setStrictErrorChecking(boolean strictErrorChecking)

Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

Specified by:
  `setStrictErrorChecking` in interface `Document`
Since:
  DOM Level 3 NEEDSDOC @param strictErrorChecking

#### setUserData

    public java.lang.Object setUserData(java.lang.String key,
                               java.lang.Object data,
                               UserDataHandler handler)

Description copied from interface: `Node`
Associate an object to a key on this node. The object can later be retrieved from this node by calling `getUserData` with the same key.

Specified by:
  `setUserData` in interface `Node`
Parameters:
  `key` - The key to associate the object to.
  `data` - The object to associate to the given key, or `null` to remove any existing association to that key.
  `handler` - The handler to associate to that key, or `null`.
Returns:
  Returns the `DOMUserData` previously associated to the given key on this node, or `null` if there was none.

#### getUserData

    public java.lang.Object getUserData(java.lang.String key)

Retrieves the object associated to a key on a this node. The object must first have been set to this node by calling `setUserData` with the same key.

Specified by:
  `getUserData` in interface `Node`
Parameters:
  `key` - The key the object is associated to.
Returns:
  Returns the `DOMObject` associated to the given key on this node, or `null` if there was none.
Since:
  DOM Level 3

#### getFeature

    public java.lang.Object getFeature(java.lang.String feature,
                              java.lang.String version)

This method returns a specialized object which implements the specialized APIs of the specified feature and version. The specialized object may also be obtained by using binding-specific casting methods but is not necessarily expected to, as discussed in Mixed DOM implementations.

Specified by:
  `getFeature` in interface `Node`
Parameters:
  `feature` - The name of the feature requested (case-insensitive).
  `version` - This is the version number of the feature to test. If the version is `null` or the empty string, supporting any version of the feature will cause the method to return an object that supports at least one version of the feature.
Returns:
  Returns an object which implements the specialized APIs of the specified feature and version, if any, or `null` if there is no object which implements interfaces associated with that feature. If the `DOMObject` returned by this method implements the `Node` interface, it must delegate to the primary core `Node` and not return results inconsistent with the primary core `Node` such as attributes, childNodes, etc.
Since:
  DOM Level 3

#### isEqualNode

    public boolean isEqualNode(Node arg)

Tests whether two nodes are equal.
This method tests for equality of nodes, not sameness (i.e., whether the two nodes are references to the same object) which can be tested with `Node.isSameNode`. All nodes that are the same will also be equal, though the reverse may not be true.
Two nodes are equal if and only if the following conditions are satisfied: The two nodes are of the same type.The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` , `baseURI`. This is: they are both `null`, or they have the same length and are character for character identical. The `attributes` `NamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.The `childNodes` `NodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. This is true for `Attr` nodes as for any other type of node. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
For two `DocumentType` nodes to be equal, the following conditions must also be satisfied: The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.The `entities` `NamedNodeMaps` are equal.The `notations` `NamedNodeMaps` are equal.
On the other hand, the following do not affect equality: the `ownerDocument` attribute, the `specified` attribute for `Attr` nodes, the `isWhitespaceInElementContent` attribute for `Text` nodes, as well as any user data or event listeners registered on the nodes.

Specified by:
  `isEqualNode` in interface `Node`
Parameters:
  `arg` - The node to compare equality with.
  `deep` - If `true`, recursively compare the subtrees; if `false`, compare only the nodes themselves (and its attributes, if it is an `Element`).
Returns:
  If the nodes, and possibly subtrees are equal, `true` otherwise `false`.
Since:
  DOM Level 3

#### lookupNamespaceURI

    public java.lang.String lookupNamespaceURI(java.lang.String specifiedPrefix)

DOM Level 3: Look up the namespace URI associated to the given prefix, starting from this node. Use lookupNamespaceURI(null) to lookup the default namespace

Specified by:
  `lookupNamespaceURI` in interface `Node`
Parameters:
  `namespaceURI` -
Returns:
  th URI for the namespace
Since:
  DOM Level 3

#### isDefaultNamespace

    public boolean isDefaultNamespace(java.lang.String namespaceURI)

DOM Level 3: This method checks if the specified `namespaceURI` is the default namespace or not.

Specified by:
  `isDefaultNamespace` in interface `Node`
Parameters:
  `namespaceURI` - The namespace URI to look for.
Returns:
  `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.
Since:
  DOM Level 3

#### lookupPrefix

    public java.lang.String lookupPrefix(java.lang.String namespaceURI)

DOM Level 3: Look up the prefix associated to the given namespace URI, starting from this node.

Specified by:
  `lookupPrefix` in interface `Node`
Parameters:
  `namespaceURI` -
Returns:
  the prefix for the namespace

#### isSameNode

    public boolean isSameNode(Node other)

Returns whether this node is the same node as the given one.
This method provides a way to determine whether two `Node` references returned by the implementation reference the same object. When two `Node` references are references to the same object, even if through a proxy, the references may be used completely interchangably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.

Specified by:
  `isSameNode` in interface `Node`
Parameters:
  `other` - The node to test against.
Returns:
  Returns `true` if the nodes are the same, `false` otherwise.
Since:
  DOM Level 3

#### setTextContent

    public void setTextContent(java.lang.String textContent)
                        throws DOMException

This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
The string returned is made of the text content of this node depending on its type, as defined below:

Node type | Content
--- | ---
ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

Specified by:
  `setTextContent` in interface `Node`
Throws:
  `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
  `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
Since:
  DOM Level 3

#### getTextContent

    public java.lang.String getTextContent()
                                    throws DOMException

This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
The string returned is made of the text content of this node depending on its type, as defined below:

Node type | Content
--- | ---
ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

Specified by:
  `getTextContent` in interface `Node`
Throws:
  `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
  `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
Since:
  DOM Level 3

#### compareDocumentPosition

    public short compareDocumentPosition(Node other)
                                  throws DOMException

Compares a node with this node with regard to their position in the document.

Specified by:
  `compareDocumentPosition` in interface `Node`
Parameters:
  `other` - The node to compare against this node.
Returns:
  Returns how the given node is positioned relatively to this node.
Throws:
  `DOMException` - NOT_SUPPORTED_ERR: when the compared nodes are from different DOM implementations that do not coordinate to return consistent implementation-specific results.
Since:
  DOM Level 3

#### getBaseURI

    public java.lang.String getBaseURI()

The absolute base URI of this node or `null` if undefined. This value is computed according to . However, when the `Document` supports the feature "HTML" , the base URI is computed using first the value of the href attribute of the HTML BASE element if any, and the value of the `documentURI` attribute from the `Document` interface otherwise.
When the node is an `Element`, a `Document` or a a `ProcessingInstruction`, this attribute represents the properties [base URI] defined in . When the node is a `Notation`, an `Entity`, or an `EntityReference`, this attribute represents the properties [declaration base URI] in the . How will this be affected by resolution of relative namespace URIs issue?It's not.Should this only be on Document, Element, ProcessingInstruction, Entity, and Notation nodes, according to the infoset? If not, what is it equal to on other nodes? Null? An empty string? I think it should be the parent's.No.Should this be read-only and computed or and actual read-write attribute?Read-only and computed (F2F 19 Jun 2000 and teleconference 30 May 2001).If the base HTML element is not yet attached to a document, does the insert change the Document.baseURI? Yes. (F2F 26 Sep 2001)

Specified by:
  `getBaseURI` in interface `Node`
Since:
  DOM Level 3

#### renameNode

    public Node renameNode(Node n,
                  java.lang.String namespaceURI,
                  java.lang.String name)
                    throws DOMException

DOM Level 3 Renaming node

Specified by:
  `renameNode` in interface `Document`
Parameters:
  `n` - The node to rename.
  `namespaceURI` - The new namespace URI.
  `name` - The new qualified name.
Returns:
  The renamed node. This is either the specified node or the new node that was created to replace the specified node.
Throws:
  `DOMException` - NOT_SUPPORTED_ERR: Raised when the type of the specified node is neither `ELEMENT_NODE` nor `ATTRIBUTE_NODE`, or if the implementation does not support the renaming of the document element.
  INVALID_CHARACTER_ERR: Raised if the new qualified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
  WRONG_DOCUMENT_ERR: Raised when the specified node was created from a different document than this document.
  NAMESPACE_ERR: Raised if the `qualifiedName` is a malformed qualified name, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, or if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace" [XML Namespaces] . Also raised, when the node being renamed is an attribute, if the `qualifiedName`, or its prefix, is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/".

#### normalizeDocument

    public void normalizeDocument()

DOM Level 3 Normalize document.

Specified by:
  `normalizeDocument` in interface `Document`

#### getDomConfig

    public DOMConfiguration getDomConfig()

The configuration used when `Document.normalizeDocument` is invoked.

Specified by:
  `getDomConfig` in interface `Document`
Since:
  DOM Level 3

#### setDocumentURI

    public void setDocumentURI(java.lang.String documentURI)

DOM Level 3

Specified by:
  `setDocumentURI` in interface `Document`

#### getDocumentURI

    public java.lang.String getDocumentURI()

DOM Level 3 The location of the document or `null` if undefined.
Beware that when the `Document` supports the feature "HTML" , the href attribute of the HTML BASE element takes precedence over this attribute.

Specified by:
  `getDocumentURI` in interface `Document`
Since:
  DOM Level 3

#### getActualEncoding

    public java.lang.String getActualEncoding()

DOM Level 3 An attribute specifying the actual encoding of this document. This is `null` otherwise.
This attribute represents the property [character encoding scheme] defined in .

Since:
  DOM Level 3

#### setActualEncoding

    public void setActualEncoding(java.lang.String value)

DOM Level 3 An attribute specifying the actual encoding of this document. This is `null` otherwise.
This attribute represents the property [character encoding scheme] defined in .

Since:
  DOM Level 3

#### replaceWholeText

    public Text replaceWholeText(java.lang.String content)
                          throws DOMException

DOM Level 3

Throws:
  `DOMException`

#### getWholeText

    public java.lang.String getWholeText()

DOM Level 3 Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.

Since:
  DOM Level 3

#### isWhitespaceInElementContent

    public boolean isWhitespaceInElementContent()

DOM Level 3 Returns whether this text node contains whitespace in element content, often abusively called "ignorable whitespace".

#### setIdAttribute

    public void setIdAttribute(boolean id)

NON-DOM: set the type of this attribute to be ID type.

Parameters:
  `id` -

#### setIdAttribute

    public void setIdAttribute(java.lang.String name,
                      boolean makeId)

DOM Level 3: register the given attribute node as an ID attribute

Specified by:
  `setIdAttribute` in interface `Element`
Parameters:
  `name` - The name of the attribute.
  `makeId` - Whether the attribute is a of type ID.

#### setIdAttributeNode

    public void setIdAttributeNode(Attr at,
                          boolean makeId)

DOM Level 3: register the given attribute node as an ID attribute

Specified by:
  `setIdAttributeNode` in interface `Element`
Parameters:
  `at` - The attribute node.
  `makeId` - Whether the attribute is a of type ID.

#### setIdAttributeNS

    public void setIdAttributeNS(java.lang.String namespaceURI,
                        java.lang.String localName,
                        boolean makeId)

DOM Level 3: register the given attribute node as an ID attribute

Specified by:
  `setIdAttributeNS` in interface `Element`
Parameters:
  `namespaceURI` - The namespace URI of the attribute.
  `localName` - The local name of the attribute.
  `makeId` - Whether the attribute is a of type ID.

#### getSchemaTypeInfo

    public TypeInfo getSchemaTypeInfo()

Method getSchemaTypeInfo.

Specified by:
  `getSchemaTypeInfo` in interface `Element`
Returns:
  TypeInfo

#### isId

    public boolean isId()

#### getXmlEncoding

    public java.lang.String getXmlEncoding()

Description copied from interface: `Document`
An attribute specifying, as part of the XML declaration, the encoding of this document. This is `null` when unspecified or when it is not known, such as when the `Document` was created in memory.

Specified by:
  `getXmlEncoding` in interface `Document`

#### setXmlEncoding

    public void setXmlEncoding(java.lang.String xmlEncoding)

#### getXmlStandalone

    public boolean getXmlStandalone()

Description copied from interface: `Document`
An attribute specifying, as part of the XML declaration, whether this document is standalone. This is `false` when unspecified.

Note: No verification is done on the value when setting this attribute. Applications should use `Document.normalizeDocument()` with the "validate" parameter to verify if the value matches the validity constraint for standalone document declaration as defined in [XML 1.0].

Specified by:
  `getXmlStandalone` in interface `Document`

#### setXmlStandalone

    public void setXmlStandalone(boolean xmlStandalone)
                          throws DOMException

Description copied from interface: `Document`
An attribute specifying, as part of the XML declaration, whether this document is standalone. This is `false` when unspecified.

Note: No verification is done on the value when setting this attribute. Applications should use `Document.normalizeDocument()` with the "validate" parameter to verify if the value matches the validity constraint for standalone document declaration as defined in [XML 1.0].

Specified by:
  `setXmlStandalone` in interface `Document`
Throws:
  `DOMException` - NOT_SUPPORTED_ERR: Raised if this document does not support the "XML" feature.

#### getXmlVersion

    public java.lang.String getXmlVersion()

Description copied from interface: `Document`
An attribute specifying, as part of the XML declaration, the version number of this document. If there is no declaration and if this document supports the "XML" feature, the value is `"1.0"`. If this document does not support the "XML" feature, the value is always `null`. Changing this attribute will affect methods that check for invalid characters in XML names. Application should invoke `Document.normalizeDocument()` in order to check for invalid characters in the `Node`s that are already part of this `Document`.
DOM applications may use the `DOMImplementation.hasFeature(feature, version)` method with parameter values "XMLVersion" and "1.0" (respectively) to determine if an implementation supports [XML 1.0]. DOM applications may use the same method with parameter values "XMLVersion" and "1.1" (respectively) to determine if an implementation supports [XML 1.1]. In both cases, in order to support XML, an implementation must also support the "XML" feature defined in this specification. `Document` objects supporting a version of the "XMLVersion" feature must not raise a `NOT_SUPPORTED_ERR` exception for the same version number when using `Document.xmlVersion`.

Specified by:
  `getXmlVersion` in interface `Document`

#### setXmlVersion

    public void setXmlVersion(java.lang.String xmlVersion)
                       throws DOMException

Description copied from interface: `Document`
An attribute specifying, as part of the XML declaration, the version number of this document. If there is no declaration and if this document supports the "XML" feature, the value is `"1.0"`. If this document does not support the "XML" feature, the value is always `null`. Changing this attribute will affect methods that check for invalid characters in XML names. Application should invoke `Document.normalizeDocument()` in order to check for invalid characters in the `Node`s that are already part of this `Document`.
DOM applications may use the `DOMImplementation.hasFeature(feature, version)` method with parameter values "XMLVersion" and "1.0" (respectively) to determine if an implementation supports [XML 1.0]. DOM applications may use the same method with parameter values "XMLVersion" and "1.1" (respectively) to determine if an implementation supports [XML 1.1]. In both cases, in order to support XML, an implementation must also support the "XML" feature defined in this specification. `Document` objects supporting a version of the "XMLVersion" feature must not raise a `NOT_SUPPORTED_ERR` exception for the same version number when using `Document.xmlVersion`.

Specified by:
  `setXmlVersion` in interface `Document`
Throws:
  `DOMException` - NOT_SUPPORTED_ERR: Raised if the version is set to a value that is not supported by this `Document` or if this document does not support the "XML" feature.